lparameters taArray, ;
	tcCDXName, ;
	tuWorkarea
local lcCDXName, ;
	lcAlias, ;
	lnTags, ;
	lnI, ;
	lcTag, ;
	lcType, ;
	lcExpr, ;
	lcFilter, ;
	lcOrder, ;
	lcCollate

* If the CDX was specified, use it. Otherwise, we'll use the structural CDX.

lcCDXName = iif(vartype(tcCDXName) = 'C' and not empty(tcCDXName), tcCDXName, ;
	'')

* If an alias or workarea was specified, use it. Otherwise, use the current
* workarea.

if pcount() = 3
	lcAlias = alias(tuWorkArea)
else
	lcAlias = alias()
endif pcount() = 3

* Ensure we have a valid alias.

if empty(lcAlias) or not used(lcAlias)
	error 13, lcAlias
endif empty(lcAlias) ...

* Get the number of tags, dimension the array, and get the information for each
* tag.

lnTags = tagcount(lcCDXName, lcAlias)
dimension taArray[lnTags, 6]
for lnI = 1 to lnTags
	lcTag = tag(lcCDXName, lnI, lcAlias)
	do case
		case primary(lnI, lcAlias)
			lcType = 'PRIMARY'
		case candidate(lnI, lcAlias)
			lcType = 'CANDIDATE'
		case unique(lnI, lcAlias)
			lcType = 'UNIQUE'
		otherwise
			lcType = 'REGULAR'
	endcase
	lcExpr    = key(lcCDXName, lnI, lcAlias)
	lcFilter  = for(lnI, lcAlias)
	lcOrder   = iif(descending(lcCDXName, lnI, lcAlias), 'DESCENDING', ;
		'ASCENDING')
	lcCollate = idxcollate(lcCDXName, lnI, lcAlias)
	taArray[lnI, 1] = lcTag
	taArray[lnI, 2] = lcType
	taArray[lnI, 3] = lcExpr
	taArray[lnI, 4] = lcFilter
	taArray[lnI, 5] = lcOrder
	taArray[lnI, 6] = lcCollate
next lnI
return lnTags
