*==============================================================================
* Program:			RevertAllTables
* Purpose:			Reverts changes in all tables in all datasessions
* Author:			Doug Hennig, mailto:dhennig@stonefield.com
* Copyright:		(c) 2000 Stonefield Systems Group Inc.
* Web site:			http://www.stonefield.com
* Last revision:	12/01/2000
* Parameters:		none
* Returns:			.T.
* Environment in:	none
* Environment out:	all transactions have been rolled back and all tables in
*						all datasessions have been reverted
*==============================================================================

local laSessions[1], ;
	lnI, ;
	laCursors[1], ;
	lnJ, ;
	lcAlias

* Rollback all transactions.

do while txnlevel() > 0
	rollback
enddo while txnlevel() > 0

* Go through all datasessions and revert all tables in them.

for lnI = 1 to asessions(laSessions)
	set datasession to laSessions[lnI]
	for lnJ = 1 to aused(laCursors)
		lcAlias = laCursors[lnJ, 1]
		if cursorgetprop('Buffering', lcAlias) > 1
			tablerevert(.T., lcAlias)
		endif cursorgetprop('Buffering', lcAlias) > 1
	next lnJ
next lnI
